devtools: disable automatic probing in null testing
[dpdk.git] / devtools / test-meson-builds.sh
1 #! /bin/sh -e
2 # SPDX-License-Identifier: BSD-3-Clause
3 # Copyright(c) 2018 Intel Corporation
4
5 # Run meson to auto-configure the various builds.
6 # * all builds get put in a directory whose name starts with "build-"
7 # * if a build-directory already exists we assume it was properly configured
8 # Run ninja after configuration is done.
9
10 # set pipefail option if possible
11 PIPEFAIL=""
12 set -o | grep -q pipefail && set -o pipefail && PIPEFAIL=1
13
14 srcdir=$(dirname $(readlink -f $0))/..
15 MESON=${MESON:-meson}
16 use_shared="--default-library=shared"
17
18 if command -v gmake >/dev/null 2>&1 ; then
19         MAKE=gmake
20 else
21         MAKE=make
22 fi
23 if command -v ninja >/dev/null 2>&1 ; then
24         ninja_cmd=ninja
25 elif command -v ninja-build >/dev/null 2>&1 ; then
26         ninja_cmd=ninja-build
27 else
28         echo "ERROR: ninja is not found" >&2
29         exit 1
30 fi
31 if command -v ccache >/dev/null 2>&1 ; then
32         CCACHE=ccache
33 else
34         CCACHE=
35 fi
36
37 default_path=$PATH
38 default_pkgpath=$PKG_CONFIG_PATH
39
40 load_env () # <target compiler>
41 {
42         targetcc=$1
43         export PATH=$default_path
44         export PKG_CONFIG_PATH=$default_pkgpath
45         unset DPDK_MESON_OPTIONS
46         command -v $targetcc >/dev/null 2>&1 || return 1
47         DPDK_TARGET=$($targetcc -v 2>&1 | sed -n 's,^Target: ,,p')
48         . $srcdir/devtools/load-devel-config
49 }
50
51 build () # <directory> <target compiler> <meson options>
52 {
53         builddir=$1
54         shift
55         targetcc=$1
56         shift
57         # skip build if compiler not available
58         command -v ${CC##* } >/dev/null 2>&1 || return 0
59         load_env $targetcc || return 0
60         if [ ! -f "$builddir/build.ninja" ] ; then
61                 options="--werror -Dexamples=all"
62                 for option in $DPDK_MESON_OPTIONS ; do
63                         options="$options -D$option"
64                 done
65                 options="$options $*"
66                 echo "$MESON $options $srcdir $builddir"
67                 $MESON $options $srcdir $builddir
68                 unset CC
69         fi
70         if [ -n "$TEST_MESON_BUILD_VERY_VERBOSE" ] ; then
71                 # for full output from ninja use "-v"
72                 echo "$ninja_cmd -v -C $builddir"
73                 $ninja_cmd -v -C $builddir
74         elif [ -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
75                 # for keeping the history of short cmds, pipe through cat
76                 echo "$ninja_cmd -C $builddir | cat"
77                 $ninja_cmd -C $builddir | cat
78         else
79                 echo "$ninja_cmd -C $builddir"
80                 $ninja_cmd -C $builddir
81         fi
82 }
83
84 if [ "$1" = "-vv" ] ; then
85         TEST_MESON_BUILD_VERY_VERBOSE=1
86 elif [ "$1" = "-v" ] ; then
87         TEST_MESON_BUILD_VERBOSE=1
88 fi
89 # we can't use plain verbose when we don't have pipefail option so up-level
90 if [ -z "$PIPEFAIL" -a -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
91         echo "# Missing pipefail shell option, changing VERBOSE to VERY_VERBOSE"
92         TEST_MESON_BUILD_VERY_VERBOSE=1
93 fi
94
95 # shared and static linked builds with gcc and clang
96 for c in gcc clang ; do
97         command -v $c >/dev/null 2>&1 || continue
98         for s in static shared ; do
99                 export CC="$CCACHE $c"
100                 build build-$c-$s $c --default-library=$s
101         done
102 done
103
104 # test compilation with minimal x86 instruction set
105 # Set the install path for libraries to "lib" explicitly to prevent problems
106 # with pkg-config prefixes if installed in "lib/x86_64-linux-gnu" later.
107 default_machine='nehalem'
108 ok=$(cc -march=$default_machine -E - < /dev/null > /dev/null 2>&1 || echo false)
109 if [ "$ok" = "false" ] ; then
110         default_machine='corei7'
111 fi
112 build build-x86-default cc -Dlibdir=lib -Dmachine=$default_machine $use_shared
113
114 c=aarch64-linux-gnu-gcc
115 # generic armv8a with clang as host compiler
116 export CC="clang"
117 build build-arm64-host-clang $c $use_shared \
118         --cross-file $srcdir/config/arm/arm64_armv8_linux_gcc
119 # all gcc/arm configurations
120 for f in $srcdir/config/arm/arm64_[bdo]*gcc ; do
121         export CC="$CCACHE gcc"
122         build build-$(basename $f | tr '_' '-' | cut -d'-' -f-2) $c \
123                 $use_shared --cross-file $f
124 done
125
126 # Test installation of the x86-default target, to be used for checking
127 # the sample apps build using the pkg-config file for cflags and libs
128 build_path=build-x86-default
129 export DESTDIR=$(pwd)/$build_path/install-root
130 $ninja_cmd -C $build_path install
131
132 load_env cc
133 pc_file=$(find $DESTDIR -name libdpdk.pc)
134 export PKG_CONFIG_PATH=$(dirname $pc_file):$PKG_CONFIG_PATH
135
136 # if pkg-config defines the necessary flags, test building some examples
137 if pkg-config --define-prefix libdpdk >/dev/null 2>&1; then
138         export PKGCONF="pkg-config --define-prefix"
139         for example in cmdline helloworld l2fwd l3fwd skeleton timer; do
140                 echo "## Building $example"
141                 $MAKE -C $DESTDIR/usr/local/share/dpdk/examples/$example clean all
142         done
143 fi